gi-gio-2.0.38: Gio bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gio.Interfaces.ListModel

Contents

- Exported types
- Methods
  - getItem
  - getItemType
  - getNItems
  - itemsChanged
- Signals
  - itemsChanged

Description

`GListModel` is an interface that represents a mutable list of `Object`. Its main intention is as a model for various widgets in user interfaces, such as list views, but it can also be used as a convenient method of returning lists of data, with support for updates.

Each object in the list may also report changes in itself via some mechanism (normally the Object::notify signal). Taken together with the ListModel::itemsChanged signal, this provides for a list that can change its membership, and in which the members can change their individual properties.

A good example would be the list of visible wireless network access points, where each access point can report dynamic properties such as signal strength.

It is important to note that the `GListModel` itself does not report changes to the individual items. It only reports changes to the list membership. If you want to observe changes to the objects themselves then you need to connect signals to the objects that you are interested in.

All items in a `GListModel` are of (or derived from) the same type. `listModelGetItemType` returns that type. The type may be an interface, in which case all objects in the list must implement it.

The semantics are close to that of an array: `listModelGetNItems` returns the number of items in the list and `listModelGetItem` returns an item at a (0-based) position. In order to allow implementations to calculate the list length lazily, you can also iterate over items: starting from 0, repeatedly call `listModelGetItem` until it returns `NULL`.

An implementation may create objects lazily, but must take care to return the same object for a given position until all references to it are gone.

On the other side, a consumer is expected only to hold references on objects that are currently ‘user visible’, in order to facilitate the maximum level of laziness in the implementation of the list and to reduce the required number of signal connections at a given time.

This interface is intended only to be used from a single thread. The thread in which it is appropriate to use it depends on the particular implementation, but typically it will be from the thread that owns the thread-default main context (see `mainContextPushThreadDefault`) in effect at the time that the model was created.

Over time, it has established itself as good practice for list model implementations to provide properties `item-type` and `n-items` to ease working with them. While it is not required, it is recommended that implementations provide these two properties. They should return the values of `listModelGetItemType` and `listModelGetNItems` respectively and be defined as such:

### c code

    properties[PROP_ITEM_TYPE] =
      g_param_spec_gtype ("item-type", NULL, NULL, G_TYPE_OBJECT,
                          G_PARAM_CONSTRUCT_ONLY | G_PARAM_READWRITE | G_PARAM_STATIC_STRINGS);
    properties[PROP_N_ITEMS] =
      g_param_spec_uint ("n-items", NULL, NULL, 0, G_MAXUINT, 0,
                         G_PARAM_READABLE | G_PARAM_STATIC_STRINGS);

Synopsis

- newtype ListModel = ListModel (ManagedPtr ListModel)
- class (GObject o, IsDescendantOf ListModel o) => IsListModel o
- toListModel :: (MonadIO m, IsListModel o) => o -> m ListModel
- listModelGetItem :: (HasCallStack, MonadIO m, IsListModel a) => a -> Word32 -> m (Maybe Object)
- listModelGetItemType :: (HasCallStack, MonadIO m, IsListModel a) => a -> m GType
- listModelGetNItems :: (HasCallStack, MonadIO m, IsListModel a) => a -> m Word32
- listModelItemsChanged :: (HasCallStack, MonadIO m, IsListModel a) => a -> Word32 -> Word32 -> Word32 -> m ()
- type ListModelItemsChangedCallback = Word32 -> Word32 -> Word32 -> IO ()
- afterListModelItemsChanged :: (IsListModel a, MonadIO m) => a -> ((?self :: a) => ListModelItemsChangedCallback) -> m SignalHandlerId
- onListModelItemsChanged :: (IsListModel a, MonadIO m) => a -> ((?self :: a) => ListModelItemsChangedCallback) -> m SignalHandlerId

# Exported types

newtype ListModel Source #

Memory-managed wrapper type.

Constructors

ListModel (ManagedPtr ListModel) |

#### Instances

Instances details

Eq ListModel Source # |
Instance details Defined in GI.Gio.Interfaces.ListModel Methods (==) :: ListModel -> ListModel -> Bool Source # (/=) :: ListModel -> ListModel -> Bool Source #
GObject ListModel Source # |
Instance details Defined in GI.Gio.Interfaces.ListModel
ManagedPtrNewtype ListModel Source # |
Instance details Defined in GI.Gio.Interfaces.ListModel Methods toManagedPtr :: ListModel -> ManagedPtr ListModel Source #
TypedObject ListModel Source # |
Instance details Defined in GI.Gio.Interfaces.ListModel Methods glibType :: IO GType Source #
HasParentTypes ListModel Source # |
Instance details Defined in GI.Gio.Interfaces.ListModel
IsGValue (Maybe ListModel) Source # | Convert `ListModel` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gio.Interfaces.ListModel Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe ListModel -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe ListModel) Source #
type ParentTypes ListModel Source # |
Instance details Defined in GI.Gio.Interfaces.ListModel type ParentTypes ListModel = '[Object]

class (GObject o, IsDescendantOf ListModel o) => IsListModel o Source #

Type class for types which can be safely cast to `ListModel`, for instance with `toListModel`.

#### Instances

Instances details

(GObject o, IsDescendantOf ListModel o) => IsListModel o Source # |
Instance details Defined in GI.Gio.Interfaces.ListModel

toListModel :: (MonadIO m, IsListModel o) => o -> m ListModel Source #

Cast to `ListModel`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, forceFloating, freezeNotify, getv, isFloating, itemsChanged, notify, notifyByPspec, ref, refSink, runDispose, stealData, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getData, getItem, getItemType, getNItems, getProperty, getQdata.

#### Setters

setData, setDataFull, setProperty.

## getItem

listModelGetItem Source #

Arguments

:: (HasCallStack, MonadIO m, IsListModel a) |
=> a | `list`: a `ListModel`
-> Word32 | `position`: the position of the item to fetch
-> m (Maybe Object) | Returns: the object at `position`.

Get the item at `position`.

If `position` is greater than the number of items in `list`, `Nothing` is returned.

`Nothing` is never returned for an index that is smaller than the length of the list.

This function is meant to be used by language bindings in place of `g_list_model_get_item()`.

See also: `listModelGetNItems`

Since: 2.44

## getItemType

listModelGetItemType Source #

Arguments

:: (HasCallStack, MonadIO m, IsListModel a) |
=> a | `list`: a `ListModel`
-> m GType | Returns: the `GType` of the items contained in `list`.

Gets the type of the items in `list`.

All items returned from `g_list_model_get_item()` are of the type returned by this function, or a subtype, or if the type is an interface, they are an implementation of that interface.

The item type of a `ListModel` can not change during the life of the model.

Since: 2.44

## getNItems

listModelGetNItems Source #

Arguments

:: (HasCallStack, MonadIO m, IsListModel a) |
=> a | `list`: a `ListModel`
-> m Word32 | Returns: the number of items in `list`.

Gets the number of items in `list`.

Depending on the model implementation, calling this function may be less efficient than iterating the list with increasing values for `position` until `g_list_model_get_item()` returns `Nothing`.

Since: 2.44

## itemsChanged

listModelItemsChanged Source #

Arguments

:: (HasCallStack, MonadIO m, IsListModel a) |
=> a | `list`: a `ListModel`
-> Word32 | `position`: the position at which `list` changed
-> Word32 | `removed`: the number of items removed
-> Word32 | `added`: the number of items added
-> m () |

Emits the ListModel::itemsChanged signal on `list`.

This function should only be called by classes implementing `ListModel`. It has to be called after the internal representation of `list` has been updated, because handlers connected to this signal might query the new state of the list.

Implementations must only make changes to the model (as visible to its consumer) in places that will not cause problems for that consumer. For models that are driven directly by a write API (such as `ListStore`), changes can be reported in response to uses of that API. For models that represent remote data, changes should only be made from a fresh mainloop dispatch. It is particularly not permitted to make changes in response to a call to the `ListModel` consumer API.

Stated another way: in general, it is assumed that code making a series of accesses to the model via the API, without returning to the mainloop, and without calling other code, will continue to view the same contents of the model.

Since: 2.44

# Signals

## itemsChanged

type ListModelItemsChangedCallback Source #

Arguments

= Word32 | `position`: the position at which `list` changed
-> Word32 | `removed`: the number of items removed
-> Word32 | `added`: the number of items added
-> IO () |

This signal is emitted whenever items were added to or removed from `list`. At `position`, `removed` items were removed and `added` items were added in their place.

Note: If `removed != added`, the positions of all later items in the model change.

Since: 2.44

afterListModelItemsChanged :: (IsListModel a, MonadIO m) => a -> ((?self :: a) => ListModelItemsChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the itemsChanged signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after listModel #itemsChanged callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onListModelItemsChanged :: (IsListModel a, MonadIO m) => a -> ((?self :: a) => ListModelItemsChangedCallback) -> m SignalHandlerId Source #

Connect a signal handler for the itemsChanged signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on listModel #itemsChanged callback